Loading...
Searching...
No Matches
Sip_session_expires

## Data Structures

struct | sip_session_expires_s
| Structure for Session-Expires header. More...

## Macros

#define | sip_session_expires(sip)
| Access a SIP Session-Expires header structure sip_session_expires_t from sip_t.
#define | SIP_SESSION_EXPIRES_INIT()
| Initializer for structure sip_session_expires_t.
#define | SIPTAG_SESSION_EXPIRES(x)
| Tag list item for pointer to a Session-Expires header structure sip_session_expires_t.
#define | SIPTAG_SESSION_EXPIRES_REF(x)
| Tag list item for reference to a Session-Expires header pointer.
#define | SIPTAG_SESSION_EXPIRES_STR(s)
| Tag list item for string with Session-Expires header value.
#define | SIPTAG_SESSION_EXPIRES_STR_REF(x)
| Tag list item for reference to a Session-Expires header string.

## Typedefs

typedef struct sip_session_expires_s | sip_session_expires_t
| @

## Functions

issize_t | sip_session_expires_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Session-Expires header.
issize_t | sip_session_expires_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Session-Expires header.
sip_session_expires_t * | sip_session_expires_init (sip_session_expires_t x[1])
| Initialize a structure sip_session_expires_t.
int | sip_is_session_expires (sip_header_t const *header)
| Test if header object is instance of sip_session_expires_t.
sip_session_expires_t * | sip_session_expires_dup (su_home_t *home, sip_session_expires_t const *hdr))
| Duplicate a list of Session-Expires header header structures sip_session_expires_t.
sip_session_expires_t * | sip_session_expires_copy (su_home_t *home, sip_session_expires_t const *hdr))
| Copy a list of Session-Expires header header structures sip_session_expires_t.
sip_session_expires_t * | sip_session_expires_make (su_home_t *home, char const *s))
| Make a Session-Expires header structure sip_session_expires_t.
sip_session_expires_t * | sip_session_expires_format (su_home_t *home, char const *fmt,...)))
| Make a Session-Expires header from formatting result.

## Variables

msg_hclass_t | sip_session_expires_class []
| Header class for Session-Expires header.
tag_typedef_t | siptag_session_expires
| Tag for Session-Expires header object.
tag_typedef_t | siptag_session_expires_str
| Tag for string with Session-Expires header value.

## Detailed Description

## Macro Definition Documentation

## SIP_SESSION_EXPIRES_INIT

#define SIP_SESSION_EXPIRES_INIT | ( |  | ) |

Initializer for structure sip_session_expires_t.

A static sip_session_expires_t structure for Session-Expires header must be initialized with the SIP_SESSION_EXPIRES_INIT() macro. For instance,

sip_session_expires_t sip_session_expires = SIP_SESSION_EXPIRES_INIT;
sip_session_expires
#define sip_session_expires(sip)
Access a SIP Session-Expires header structure sip_session_expires_t from sip_t.
Definition sip_protos.h:12031
sip_session_expires_t
struct sip_session_expires_s sip_session_expires_t
@
Definition sip.h:190
SIP_SESSION_EXPIRES_INIT
#define SIP_SESSION_EXPIRES_INIT()
Initializer for structure sip_session_expires_t.
Definition sip_protos.h:12048

## SIPTAG_SESSION_EXPIRES

#define SIPTAG_SESSION_EXPIRES | ( |  | x | ) |

Tag list item for pointer to a Session-Expires header structure sip_session_expires_t.

The SIPTAG_SESSION_EXPIRES() macro is used to include a tag item with a pointer to a sip_session_expires_t structure in a tag list.

Parameters

  x | pointer to a sip_session_expires_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SESSION_EXPIRES_REF().

## SIPTAG_SESSION_EXPIRES_STR

#define SIPTAG_SESSION_EXPIRES_STR | ( |  | s | ) |

Tag list item for string with Session-Expires header value.

The SIPTAG_SESSION_EXPIRES_STR() macro is used to include a tag item with a string containing value of a sip_session_expires_t header in a tag list.

Parameters

  s | pointer to a string containing Session-Expires header value, or NULL.

The string in SIPTAG_SESSION_EXPIRES_STR() can be converted to a sip_session_expires_t header structure by giving the string s has second argument to function sip_session_expires_make().

The corresponding tag taking reference parameter is SIPTAG_SESSION_EXPIRES_STR_REF().

## Typedef Documentation

## sip_session_expires_t

typedef struct sip_session_expires_s sip_session_expires_t

@

The Session-Expires header is used to convey the lifetime of the session. Its syntax is defined in RFC 4028 as follows:

Session-Expires = ("Session-Expires" | "x") HCOLON delta-seconds
*(SEMI se-params)
se-params = refresher-param / generic-param
refresher-param = "refresher" EQUAL ("uas" / "uac")

The parsed Session-Expires header is stored in sip_session_expires_t structure.

The structure sip_session_expires_t contains representation of the SIP Session-Expires header.

The sip_session_expires_t is defined as follows:

typedef struct sip_session_expires_s
{
sip_common_t x_common[1];
sip_unknown_t *x_next;
unsigned long x_delta; //Delta Seconds
msg_param_t *x_params;
char const *x_refresher; //Who will send the refresh UAS or UAC
} sip_session_expires_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_session_expires_s
Structure for Session-Expires header.
Definition sip.h:703
sip_session_expires_s::x_common
sip_common_t x_common[1]
Common fragment info.
Definition sip.h:704
sip_session_expires_s::x_next
sip_error_t * x_next
Dummy link to next.
Definition sip.h:705
sip_session_expires_s::x_params
msg_param_t const * x_params
List of parameters.
Definition sip.h:707
sip_session_expires_s::x_delta
unsigned long x_delta
Delta-seconds.
Definition sip.h:706
sip_session_expires_s::x_refresher
char const * x_refresher
Value of "refresher" parameter: UAS or UAC.
Definition sip.h:708

## Function Documentation

## sip_is_session_expires()

int sip_is_session_expires | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_session_expires_t.

Check if the header class is an instance of Session-Expires header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header session_expires
  0 | (false) otherwise

## sip_session_expires_copy()

sip_session_expires_t * sip_session_expires_copy | ( | su_home_t * | home,
|  | sip_session_expires_t const * | hdr )

inline

Copy a list of Session-Expires header header structures sip_session_expires_t.

The function sip_session_expires_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  session_expires = sip_session_expires_copy(home, sip->sip_session_expires);
  sip_session_expires_copy
  sip_session_expires_t * sip_session_expires_copy(su_home_t *home, sip_session_expires_t const *hdr))
  Copy a list of Session-Expires header header structures sip_session_expires_t.
  Definition sip_protos.h:12178

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_session_expires_dup()

sip_session_expires_t * sip_session_expires_dup | ( | su_home_t * | home,
|  | sip_session_expires_t const * | hdr )

inline

Duplicate a list of Session-Expires header header structures sip_session_expires_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  session_expires = sip_session_expires_dup(home, sip->sip_session_expires);
  sip_session_expires_dup
  sip_session_expires_t * sip_session_expires_dup(su_home_t *home, sip_session_expires_t const *hdr))
  Duplicate a list of Session-Expires header header structures sip_session_expires_t.
  Definition sip_protos.h:12135

Returns
  A pointer to the newly duplicated sip_session_expires_t header structure, or NULL upon an error.

## sip_session_expires_format()

sip_session_expires_t * sip_session_expires_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Session-Expires header from formatting result.

Make a new sip_session_expires_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_session_expires_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_session_expires_init()

sip_session_expires_t * sip_session_expires_init | ( | sip_session_expires_t | x[1] | ) |

inline

Initialize a structure sip_session_expires_t.

An sip_session_expires_t structure for Session-Expires header can be initialized with the sip_session_expires_init() function/macro. For instance,

sip_session_expires_t sip_session_expires;
sip_session_expires_init(&sip_session_expires);
sip_session_expires_init
sip_session_expires_t * sip_session_expires_init(sip_session_expires_t x[1])
Initialize a structure sip_session_expires_t.
Definition sip_protos.h:12066

## sip_session_expires_make()

sip_session_expires_t * sip_session_expires_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Session-Expires header structure sip_session_expires_t.

The function sip_session_expires_make() makes a new sip_session_expires_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_session_expires_t header structure, or NULL upon an error.

## Variable Documentation

## sip_session_expires_class

msg_hclass_t sip_session_expires_class[]

extern

Header class for Session-Expires header.

The header class sip_session_expires_class defines how a SIP Session-Expires header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_session_expires_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.